blob: 0779266a795c2b0a60912f8b0d64a989b5068443 [file] [log] [blame]
Peter Stuge09377b72011-08-21 06:24:55 +02001#!/bin/sh
Stefan Reinauer074d9132009-09-26 16:43:17 +00002#
Stefan Reinauer5f1ad892010-05-17 11:02:25 +00003# Copyright (C) 2008-2010 by coresystems GmbH
Stefan Reinauer074d9132009-09-26 16:43:17 +00004# written by Patrick Georgi <patrick.georgi@coresystems.de> and
5# Stefan Reinauer <stefan.reinauer@coresystems.de>
Stefan Reinauer14e22772010-04-27 06:56:47 +00006#
Marc Jones2aac3f62011-08-08 16:07:50 -06007# Copyright (C) 2011 by Sage Electronic Engineering
8#
Stefan Reinauer074d9132009-09-26 16:43:17 +00009# This program is free software; you can redistribute it and/or modify
10# it under the terms of the GNU General Public License as published by
11# the Free Software Foundation; version 2 of the License.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the GNU General Public License
19# along with this program; if not, write to the Free Software
Paul Menzela46a7122013-02-23 18:37:27 +010020# Foundation, Inc., 51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA
Stefan Reinauer074d9132009-09-26 16:43:17 +000021#
22
Paul Menzele6619422015-02-23 10:33:59 +010023CROSSGCC_DATE="February 23th, 2015"
24CROSSGCC_VERSION="1.26"
Stefan Reinauer074d9132009-09-26 16:43:17 +000025
26# default settings
27TARGETDIR=`pwd`/xgcc
28TARGETARCH=i386-elf
29DESTDIR=
30
31# version numbers
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070032GMP_VERSION=5.1.2
33MPFR_VERSION=3.1.2
Paul Menzele6619422015-02-23 10:33:59 +010034MPC_VERSION=1.0.3
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000035LIBELF_VERSION=0.8.13
Patrick Georgid730ca82014-11-19 17:35:28 +010036GCC_VERSION=4.8.3
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070037GCC_AUTOCONF_VERSION=2.69
38BINUTILS_VERSION=2.23.2
39GDB_VERSION=7.6
Alexandru Gagniuc87cc49b2014-02-04 10:46:51 -060040IASL_VERSION=20140114
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070041PYTHON_VERSION=3.3.2
Idwer Vollering296a0152012-10-26 01:48:04 +020042EXPAT_VERSION=2.1.0
Stefan Reinauer074d9132009-09-26 16:43:17 +000043
44# archive locations
Patrick Georgi6e61ad32012-05-12 23:19:30 +020045GMP_ARCHIVE="http://ftpmirror.gnu.org/gmp/gmp-${GMP_VERSION}.tar.bz2"
46MPFR_ARCHIVE="http://ftpmirror.gnu.org/mpfr/mpfr-${MPFR_VERSION}.tar.bz2"
Idwer Vollering7962fc72012-10-25 02:14:09 +020047MPC_ARCHIVE="http://ftpmirror.gnu.org/mpc/mpc-${MPC_VERSION}.tar.gz"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000048LIBELF_ARCHIVE="http://www.mr511.de/software/libelf-${LIBELF_VERSION}.tar.gz"
Idwer Vollering1cfee0b2012-10-25 02:03:53 +020049GCC_ARCHIVE="http://ftpmirror.gnu.org/gcc/gcc-${GCC_VERSION}/gcc-${GCC_VERSION}.tar.bz2"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070050BINUTILS_ARCHIVE="http://ftpmirror.gnu.org/binutils/binutils-${BINUTILS_VERSION}.tar.bz2"
Patrick Georgi6e61ad32012-05-12 23:19:30 +020051GDB_ARCHIVE="http://ftpmirror.gnu.org/gdb/gdb-${GDB_VERSION}.tar.bz2"
Idwer Volleringe76d8d72013-04-11 12:01:19 +020052IASL_ARCHIVE="http://www.acpica.org/sites/acpica/files/acpica-unix-${IASL_VERSION}.tar.gz"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010053PYTHON_ARCHIVE="http://www.python.org/ftp/python/${PYTHON_VERSION}/Python-${PYTHON_VERSION}.tar.bz2"
54EXPAT_ARCHIVE="http://downloads.sourceforge.net/sourceforge/expat/expat-${EXPAT_VERSION}.tar.gz"
Stefan Reinauer074d9132009-09-26 16:43:17 +000055
56GMP_DIR="gmp-${GMP_VERSION}"
57MPFR_DIR="mpfr-${MPFR_VERSION}"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000058MPC_DIR="mpc-${MPC_VERSION}"
59LIBELF_DIR="libelf-${LIBELF_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000060GCC_DIR="gcc-${GCC_VERSION}"
61BINUTILS_DIR="binutils-${BINUTILS_VERSION}"
62GDB_DIR="gdb-${GDB_VERSION}"
Marc Jones2aac3f62011-08-08 16:07:50 -060063IASL_DIR="acpica-unix-${IASL_VERSION}"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010064PYTHON_DIR="Python-${PYTHON_VERSION}"
65EXPAT_DIR="expat-${EXPAT_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000066
Patrick Georgi6321f522015-02-27 23:36:26 +010067unset MAKELEVEL MAKEFLAGS
68
Stefan Reinauer074d9132009-09-26 16:43:17 +000069SAVETEMPS=0
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010070SKIPGDB=1
71SKIPPYTHON=1
Stefan Reinauer074d9132009-09-26 16:43:17 +000072
Patrick Georgi1861ff72011-10-31 12:15:55 +010073red='\033[0;31m'
74RED='\033[1;31m'
75green='\033[0;32m'
76GREEN='\033[1;32m'
77blue='\033[0;34m'
78BLUE='\033[1;34m'
79cyan='\033[0;36m'
80CYAN='\033[1;36m'
81NC='\033[0m' # No Color
Stefan Reinauer074d9132009-09-26 16:43:17 +000082
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070083UNAME=`uname`
84
Patrick Georgi198d23c2012-12-08 08:02:44 +010085normalize_dirs()
86{
87 mkdir -p $DESTDIR$TARGETDIR/lib
88 test -d $DESTDIR$TARGETDIR/lib32 && mv $DESTDIR$TARGETDIR/lib32/* $DESTDIR$TARGETDIR/lib
89 test -d $DESTDIR$TARGETDIR/lib64 && mv $DESTDIR$TARGETDIR/lib64/* $DESTDIR$TARGETDIR/lib
90 rmdir -p $DESTDIR$TARGETDIR/lib32 $DESTDIR$TARGETDIR/lib64
91
92 perl -pi -e "s,/lib32,/lib," $DESTDIR$TARGETDIR/lib/*.la
93 perl -pi -e "s,/lib64,/lib," $DESTDIR$TARGETDIR/lib/*.la
94}
95
Stefan Reinauer074d9132009-09-26 16:43:17 +000096searchgnu()
97{
98 # $1 short name
99 # result: GNU version of that tool on stdout
100 # or no output if no GNU version was found
101 for i in "$1" "g$1" "gnu$1"; do
102 if test -x "`which $i 2>/dev/null`"; then
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100103 if test `$i --version 2>/dev/null |grep -c GNU` \
104 -gt 0; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000105 echo $i
106 return
107 fi
108 fi
109 done
Andrew Wub67e9a12014-04-28 18:13:44 +0800110 # A workaround for OSX 10.9 and some BSDs, whose nongnu
111 # patch and tar also work.
112 if [ $UNAME = "Darwin" -o $UNAME = "FreeBSD" -o $UNAME = "NetBSD" ]; then
Zheng Bao36156ff2012-09-28 16:18:58 +0800113 if [ $1 != "make" ]; then
114 if test -x "`which $1 2>/dev/null`"; then
115 echo $1
116 return
117 fi
118 fi
119 fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000120 printf "${RED}ERROR:${red} Missing toolchain: $1${NC}\n" >&2
121 exit 1
122}
123
Patrick Georgi68df8042011-07-17 11:36:10 +0200124TAR=`searchgnu tar` || exit $?
125PATCH=`searchgnu patch` || exit $?
126MAKE=`searchgnu make` || exit $?
Stefan Reinauer074d9132009-09-26 16:43:17 +0000127
Patrick Georgi5fb2b5c2012-05-12 23:25:23 +0200128searchgnu m4 > /dev/null
129searchgnu bison > /dev/null
Patrick Georgi0a3f2392012-11-20 12:04:32 +0100130
131if ! flex --version > /dev/null 2> /dev/null; then
132 printf "${RED}ERROR:${red} Missing toolchain: flex${NC}\n" >&2
133 exit 1
134fi
Patrick Georgi5fb2b5c2012-05-12 23:25:23 +0200135
Stefan Reinauer074d9132009-09-26 16:43:17 +0000136cleanup()
137{
138 printf "Cleaning up temporary files... "
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200139 rm -rf ${BUILDDIRPREFIX}-* combined gcc-* gmp-* mpfr-* mpc-* libelf-* binutils-*
Patrick Georgi969cd932012-12-07 13:13:53 +0100140 rm -rf gdb-* acpica-* python-* expat-*
Stefan Reinauer074d9132009-09-26 16:43:17 +0000141 printf "${green}ok${NC}\n"
142}
143
144myhelp()
145{
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100146 printf "Usage: $0 [-V] [-c] [-p <platform>] [-d <target directory>] [-D <dest dir>] [-G] [-S]\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000147 printf " $0 [-V|--version]\n"
148 printf " $0 [-h|--help]\n\n"
149
150 printf "Options:\n"
151 printf " [-V|--version] print version number and exit\n"
152 printf " [-h|--help] print this help and exit\n"
153 printf " [-c|--clean] remove temporary files before build\n"
154 printf " [-t|--savetemps] don't remove temporary files after build\n"
Patrick Georgic1a75b12011-11-04 21:37:14 +0100155 printf " [-y|--ccache] Use ccache when building cross compiler\n"
Patrick Georgi73166c72010-04-14 20:42:42 +0000156 printf " [-j|--jobs <num>] run <num> jobs in parallel in make\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000157 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
158 printf " (defaults to $TARGETARCH)\n"
159 printf " [-d|--directory <target dir>] target directory to install cross compiler to\n"
160 printf " (defaults to $TARGETDIR)\n\n"
161 printf " [-D|--destdir <dest dir>] destination directory to install cross compiler to\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100162 printf " (for RPM builds, default unset)\n"
163 printf " [-G|--gdb] build GNU debugger\n"
164 printf " [-S|--scripting] build scripting support for GDB\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000165}
166
167myversion()
168{
169 # version tag is always printed, so just print the license here
170
171 cat << EOF
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000172Copyright (C) 2008-2010 by coresystems GmbH
Marc Jones2aac3f62011-08-08 16:07:50 -0600173Copyright (C) 2011 by Sage Electronic Engineering
Stefan Reinauer074d9132009-09-26 16:43:17 +0000174
175This program is free software; you can redistribute it and/or modify
176it under the terms of the GNU General Public License as published by
177the Free Software Foundation; version 2 of the License.
178
179This program is distributed in the hope that it will be useful,
180but WITHOUT ANY WARRANTY; without even the implied warranty of
181MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
182GNU General Public License for more details.
183
184EOF
185}
186
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700187printf "${blue}Welcome to the ${red}coreboot${blue} cross toolchain builder v$CROSSGCC_VERSION ($CROSSGCC_DATE)${NC}\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000188
Patrick Georgi6bba29f2010-01-29 17:40:52 +0000189# Look if we have getopt. If not, build it.
190export PATH=$PATH:.
191getopt - > /dev/null 2>/dev/null || gcc -o getopt getopt.c
192
Stefan Reinauer074d9132009-09-26 16:43:17 +0000193# parse parameters.. try to find out whether we're running GNU getopt
Peter Stuge09377b72011-08-21 06:24:55 +0200194getoptbrand="`getopt -V | sed -e '1!d' -e 's,^\(......\).*,\1,'`"
195if [ "${getoptbrand}" = "getopt" ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000196 # Detected GNU getopt that supports long options.
Patrick Georgic1a75b12011-11-04 21:37:14 +0100197 args=`getopt -l version,help,clean,directory:,platform:,jobs:,destdir:,savetemps,skip-gdb,ccache Vhcd:p:j:D:tGy -- "$@"`
Stefan Reinauer074d9132009-09-26 16:43:17 +0000198 eval set "$args"
199else
200 # Detected non-GNU getopt
Patrick Georgic1a75b12011-11-04 21:37:14 +0100201 args=`getopt Vhcd:p:j:D:tGy $*`
Stefan Reinauer074d9132009-09-26 16:43:17 +0000202 set -- $args
203fi
204
205if [ $? != 0 ]; then
206 myhelp
207 exit 1
208fi
209
210while true ; do
211 case "$1" in
212 -V|--version) shift; myversion; exit 0;;
213 -h|--help) shift; myhelp; exit 0;;
Patrick Georgi44af57a2013-12-19 22:06:22 +0100214 -c|--clean) shift; clean=1;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000215 -t|--savetemps) shift; SAVETEMPS=1;;
216 -d|--directory) shift; TARGETDIR="$1"; shift;;
217 -p|--platform) shift; TARGETARCH="$1"; shift;;
218 -D|--destdir) shift; DESTDIR="$1"; shift;;
Patrick Georgi73166c72010-04-14 20:42:42 +0000219 -j|--jobs) shift; JOBS="-j $1"; shift;;
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100220 -G|--gdb) shift; SKIPGDB=0;;
221 -S|--scripting) shift; SKIPPYTHON=0;;
Patrick Georgic1a75b12011-11-04 21:37:14 +0100222 -y|--ccache) shift; USECCACHE=1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200223 --) shift; break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000224 -*) printf "Invalid option\n\n"; myhelp; exit 1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200225 *) break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000226 esac
227done
228
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700229case "$TARGETARCH" in
David Hubbard5b0420a2013-05-28 16:33:15 -0600230 i386-elf) ;;
231 i386-mingw32) ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700232 i386*) TARGETARCH=i386-elf;;
Patrick Georgic8883262013-09-19 10:57:58 +0200233 arm*) TARGETARCH=armv7-a-eabi;;
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700234 aarch64*) TARGETARCH=aarch64-elf;;
235 *) printf "${red}WARNING: Unsupported architecture $TARGETARCH.${NC}\n\n"; ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700236esac
237
238echo "Target arch is now $TARGETARCH"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200239BUILDDIRPREFIX=build-${TARGETARCH}
240
Patrick Georgi44af57a2013-12-19 22:06:22 +0100241if [ "$clean" = "1" ]; then
242 cleanup
243fi
244
Peter Stugeceacd772011-06-09 04:54:16 +0200245GDB_PACKAGE="GDB"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100246PYTHON_PACKAGE="PYTHON"
247EXPAT_PACKAGE="EXPAT"
Peter Stugeceacd772011-06-09 04:54:16 +0200248if [ $SKIPGDB -eq 1 ]; then
249 printf "Will skip GDB ... ${green}ok${NC}\n"
Peter Stuge0e8ee812011-08-28 11:04:23 +0200250 GDB_ARCHIVE=""
Peter Stugeceacd772011-06-09 04:54:16 +0200251 GDB_PACKAGE=""
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100252 if [ $SKIPPYTHON -eq 0 ]; then
253 printf "Python scripting needs GDB ... disabling ... ${green}ok${NC}\n"
254 SKIPPYTHON=1
255 fi
256fi
257if [ $SKIPPYTHON -eq 1 ]; then
Jonathan A. Kollasch2d7ab4c2011-11-07 13:05:18 -0600258 PYTHON_ARCHIVE=""
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100259 PYTHON_PACKAGE=""
Jonathan A. Kollasch2d7ab4c2011-11-07 13:05:18 -0600260 EXPAT_ARCHIVE=""
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100261 EXPAT_PACKAGE=""
Peter Stugeceacd772011-06-09 04:54:16 +0200262fi
263
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700264# coreboot does not like the GOLD linker
265# USE_GOLD="--enable-gold"
266USE_GOLD=""
267GCC_OPTIONS="--enable-lto"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000268
Stefan Reinauer074d9132009-09-26 16:43:17 +0000269printf "Downloading tar balls ... \n"
270mkdir -p tarballs
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100271for ARCHIVE in $GMP_ARCHIVE $MPFR_ARCHIVE $MPC_ARCHIVE $LIBELF_ARCHIVE \
Patrick Georgi969cd932012-12-07 13:13:53 +0100272 $GCC_ARCHIVE $BINUTILS_ARCHIVE $GDB_ARCHIVE \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100273 $IASL_ARCHIVE $PYTHON_ARCHIVE $EXPAT_ARCHIVE; do
Stefan Reinauer074d9132009-09-26 16:43:17 +0000274 FILE=`basename $ARCHIVE`
275 printf " * $FILE "
276 test -f tarballs/$FILE && printf "(cached)" || (
277 printf "(downloading)"
278 cd tarballs
Patrick Georgi6e61ad32012-05-12 23:19:30 +0200279 wget --no-check-certificate -q $ARCHIVE
Stefan Reinauer074d9132009-09-26 16:43:17 +0000280 )
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100281 test -f tarballs/$FILE || \
Zheng Bao5b209c02012-09-20 16:09:51 +0800282 printf "\n${RED}Failed to download $FILE.${NC}\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000283 test -f tarballs/$FILE || exit 1
284 printf "\n"
285done
286printf "Downloaded tar balls ... "
287printf "${green}ok${NC}\n"
288
289printf "Unpacking and patching ... \n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100290for PACKAGE in GMP MPFR MPC LIBELF GCC BINUTILS $PYTHON_PACKAGE \
Patrick Georgi969cd932012-12-07 13:13:53 +0100291 $EXPAT_PACKAGE $GDB_PACKAGE IASL; do
Stefan Reinauer074d9132009-09-26 16:43:17 +0000292 archive=$PACKAGE"_ARCHIVE"
Peter Stuge09377b72011-08-21 06:24:55 +0200293 archive="`eval echo '$'$archive`"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000294 dir=$PACKAGE"_DIR"
Peter Stuge09377b72011-08-21 06:24:55 +0200295 dir="`eval echo '$'${dir}`"
Zheng Baof95bb2d2013-12-13 12:30:46 +0800296 test -d ${dir} && test -f ${dir}/.unpack_success || (
Stefan Reinauer074d9132009-09-26 16:43:17 +0000297 printf " * `basename $archive`\n"
298 FLAGS=zxf
Peter Stuge09377b72011-08-21 06:24:55 +0200299 suffix=`echo $archive | sed 's,.*\.,,'`
300 test "$suffix" = "gz" && FLAGS=zxf
301 test "$suffix" = "bz2" && FLAGS=jxf
302 test "$suffix" = "lzma" && FLAGS="--lzma -xf"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000303 $TAR $FLAGS tarballs/`basename $archive`
Peter Stuge09377b72011-08-21 06:24:55 +0200304 for patch in patches/${dir}_*.patch; do
Stefan Reinauer074d9132009-09-26 16:43:17 +0000305 test -r $patch || continue
306 printf " o `basename $patch`\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100307 $PATCH -s -N -p0 < `echo $patch` || \
Zheng Bao5b209c02012-09-20 16:09:51 +0800308 printf "\n${RED}Failed $patch.${NC}\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000309 done
Zheng Bao691b313c2013-12-09 14:09:07 +0800310 touch ${dir}/.unpack_success
Stefan Reinauer074d9132009-09-26 16:43:17 +0000311 )
312done
313printf "Unpacked and patched ... "
314printf "${green}ok${NC}\n"
315
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700316CC=cc
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700317if [ $UNAME = "Darwin" ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000318 #GCC_OPTIONS="$GCC_OPTIONS --enable-threads=posix"
319
320 # generally the OS X compiler can create x64 binaries.
321 # Per default it generated i386 binaries in 10.5 and x64
322 # binaries in 10.6 (even if the kernel is 32bit)
323 # For some weird reason, 10.5 autodetects an ABI=64 though
324 # so we're setting the ABI explicitly here.
Zheng Bao04ceed62012-10-23 19:41:25 +0800325 if [ `sysctl -n hw.optional.x86_64 2>/dev/null` -eq 1 ] 2>/dev/null; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000326 OPTIONS="ABI=64"
327 else
328 OPTIONS="ABI=32"
329 fi
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700330
Stefan Reinauer4266b922012-12-05 16:18:32 -0800331 # In Xcode 4.5.2 the default compiler is clang.
332 # However, this compiler fails to compile gcc 4.7.x. As a
333 # workaround it's possible to compile gcc with llvm-gcc.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700334 if $CC -v 2>&1 | grep -q LLVM; then
Stefan Reinauer4266b922012-12-05 16:18:32 -0800335 CC=llvm-gcc
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700336 fi
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000337fi
338
Patrick Georgic1a75b12011-11-04 21:37:14 +0100339if [ "$USECCACHE" = 1 ]; then
340 CC="ccache $CC"
341fi
342
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200343mkdir -p ${BUILDDIRPREFIX}-gmp ${BUILDDIRPREFIX}-mpfr ${BUILDDIRPREFIX}-mpc ${BUILDDIRPREFIX}-libelf ${BUILDDIRPREFIX}-binutils \
344 ${BUILDDIRPREFIX}-gcc ${BUILDDIRPREFIX}-python ${BUILDDIRPREFIX}-expat
Stefan Reinauer16bd7892012-12-07 23:57:01 +0100345
346mkdir -p $DESTDIR$TARGETDIR/bin
347export PATH=$DESTDIR$TARGETDIR/bin:$PATH
348
Peter Stugeceacd772011-06-09 04:54:16 +0200349if [ $SKIPGDB -eq 0 ]; then
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200350 mkdir -p ${BUILDDIRPREFIX}-gdb
Peter Stugeceacd772011-06-09 04:54:16 +0200351fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200352if [ -f ${BUILDDIRPREFIX}-gmp/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000353 printf "Skipping GMP as it is already built\n"
354else
355printf "Building GMP ${GMP_VERSION} ... "
356(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200357 cd ${BUILDDIRPREFIX}-gmp
Stefan Reinauer074d9132009-09-26 16:43:17 +0000358 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100359 CC="$CC" ../${GMP_DIR}/configure --disable-shared --prefix=$TARGETDIR $OPTIONS \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000360 || touch .failed
Patrick Georgi73166c72010-04-14 20:42:42 +0000361 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000362 $MAKE install DESTDIR=$DESTDIR || touch .failed
Patrick Georgi198d23c2012-12-08 08:02:44 +0100363
364 normalize_dirs
365
Stefan Reinauer074d9132009-09-26 16:43:17 +0000366 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200367) > ${BUILDDIRPREFIX}-gmp/crossgcc-build.log 2>&1
368test -r ${BUILDDIRPREFIX}-gmp/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100369 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200370test -r ${BUILDDIRPREFIX}-gmp/.failed && exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000371fi
372
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700373# Now set CFLAGS to match GMP CFLAGS but strip out -pedantic
374# as GCC 4.6.x fails if it's there.
375HOSTCFLAGS=`grep __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h |cut -d\" -f2 |\
376 sed s,-pedantic,,`
Stefan Reinauer074d9132009-09-26 16:43:17 +0000377
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200378if [ -f ${BUILDDIRPREFIX}-mpfr/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000379 printf "Skipping MPFR as it is already built\n"
380else
381printf "Building MPFR ${MPFR_VERSION} ... "
382(
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700383 test $UNAME = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200384 cd ${BUILDDIRPREFIX}-mpfr
Stefan Reinauer074d9132009-09-26 16:43:17 +0000385 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100386 CC="$CC" ../${MPFR_DIR}/configure --disable-shared --prefix=$TARGETDIR \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000387 --infodir=$TARGETDIR/info \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100388 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
389 touch .failed
Patrick Georgi73166c72010-04-14 20:42:42 +0000390 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000391 $MAKE install DESTDIR=$DESTDIR || touch .failed
392
Patrick Georgi198d23c2012-12-08 08:02:44 +0100393 normalize_dirs
394
Stefan Reinauer074d9132009-09-26 16:43:17 +0000395 # work around build problem of libgmp.la
396 if [ "$DESTDIR" != "" ]; then
397 perl -pi -e "s,$DESTDIR,," $DESTDIR$TARGETDIR/libgmp.la
398 fi
399
400 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200401) > ${BUILDDIRPREFIX}-mpfr/crossgcc-build.log 2>&1
402test -r ${BUILDDIRPREFIX}-mpfr/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100403 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200404test -r ${BUILDDIRPREFIX}-mpfr/.failed && exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000405fi
406
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200407if [ -f ${BUILDDIRPREFIX}-mpc/.success ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000408 printf "Skipping MPC as it is already built\n"
409else
410printf "Building MPC ${MPC_VERSION} ... "
411(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200412 cd ${BUILDDIRPREFIX}-mpc
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000413 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100414 CC="$CC" ../${MPC_DIR}/configure --disable-shared --prefix=$TARGETDIR \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000415 --infodir=$TARGETDIR/info --with-mpfr=$DESTDIR$TARGETDIR \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100416 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
417 touch .failed
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000418 $MAKE $JOBS || touch .failed
419 $MAKE install DESTDIR=$DESTDIR || touch .failed
420
Patrick Georgi198d23c2012-12-08 08:02:44 +0100421 normalize_dirs
422
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000423 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200424) > ${BUILDDIRPREFIX}-mpc/crossgcc-build.log 2>&1
425test -r ${BUILDDIRPREFIX}-mpc/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100426 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200427test -r ${BUILDDIRPREFIX}-mpc/.failed && exit 1
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000428fi
429
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200430if [ -f ${BUILDDIRPREFIX}-libelf/.success ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000431 printf "Skipping libelf as it is already built\n"
432else
433printf "Building libelf ${LIBELF_VERSION} ... "
434(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200435 cd ${BUILDDIRPREFIX}-libelf
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000436 rm -f .failed
437 echo "$HOSTCFLAGS"
Patrick Georgi643c9e82011-11-04 21:30:49 +0100438 CC="$CC" CFLAGS="$HOSTCFLAGS" libelf_cv_elf_h_works=no \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100439 ../${LIBELF_DIR}/configure --disable-shared --prefix=$TARGETDIR \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000440 --infodir=$TARGETDIR/info CFLAGS="$HOSTCFLAGS" || touch .failed
441 $MAKE $JOBS || touch .failed
Scott Duplichan4270a972014-12-12 20:21:40 -0600442 $MAKE install prefix=$DESTDIR$TARGETDIR || touch .failed
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000443
Patrick Georgi198d23c2012-12-08 08:02:44 +0100444 normalize_dirs
445
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000446 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200447) > ${BUILDDIRPREFIX}-libelf/crossgcc-build.log 2>&1
448test -r ${BUILDDIRPREFIX}-libelf/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100449 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200450test -r ${BUILDDIRPREFIX}-libelf/.failed && exit 1
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000451fi
452
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200453if [ -f ${BUILDDIRPREFIX}-binutils/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000454 printf "Skipping binutils as it is already built\n"
455else
456printf "Building binutils ${BINUTILS_VERSION} ... "
457(
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700458 # What a pain: binutils don't come with configure
459 # script anymore. Create it:
460 cd binutils-${BINUTILS_VERSION}/
461 autoconf
462 cd ..
463 # Now build binutils
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200464 cd ${BUILDDIRPREFIX}-binutils
Stefan Reinauer074d9132009-09-26 16:43:17 +0000465 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100466 CC="$CC" ../binutils-${BINUTILS_VERSION}/configure --prefix=$TARGETDIR \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100467 --target=${TARGETARCH} --disable-werror --disable-nls \
468 $USE_GOLD CFLAGS="$HOSTCFLAGS" || touch .failed
Patrick Georgi73166c72010-04-14 20:42:42 +0000469 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000470 $MAKE install DESTDIR=$DESTDIR || touch .failed
471 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200472) > ${BUILDDIRPREFIX}-binutils/crossgcc-build.log 2>&1
473test -r ${BUILDDIRPREFIX}-binutils/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100474 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200475test -r ${BUILDDIRPREFIX}-binutils/.failed && exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000476fi
477
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200478if [ -f ${BUILDDIRPREFIX}-gcc/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000479 printf "Skipping GCC as it is already built\n"
480else
481printf "Building GCC ${GCC_VERSION} ... "
482(
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700483 # Even worse than binutils: GCC does not come with configure
484 # script anymore, but also enforces an obsolete autoconf version
485 # to create it. This is a poster child of how autotools help make
486 # software portable.
487 cd gcc-${GCC_VERSION}
488 sed '/dnl Ensure exactly this Autoconf version is used/d' \
489 config/override.m4 > config/override.m4.new
490 autoconf_version=`autoconf -V | grep "autoconf" | tr ' ' '\n' | tail -1`
491 sed "s/${GCC_AUTOCONF_VERSION}/${autoconf_version}/g" \
492 config/override.m4.new > config/override.m4
493 autoconf
494 cd ..
495 # Now, finally, we can build gcc:
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200496 cd ${BUILDDIRPREFIX}-gcc
Stefan Reinauer074d9132009-09-26 16:43:17 +0000497 rm -f .failed
498 # GCC does not honour HOSTCFLAGS at all. CFLAGS are used for
499 # both target and host object files. This is pretty misdesigned.
500 # There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET
501 # but it does not seem to work properly. At least the host library
502 # libiberty is not compiled with CFLAGS_FOR_BUILD.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700503 CC="$CC" CFLAGS_FOR_TARGET="-O2" CFLAGS="$HOSTCFLAGS" \
504 CFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000505 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
Stefan Reinauer6ade1612010-01-16 16:44:20 +0000506 --target=${TARGETARCH} --disable-werror --disable-shared \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000507 --disable-libssp --disable-bootstrap --disable-nls \
Patrick Georgi969cd932012-12-07 13:13:53 +0100508 --disable-libquadmath --without-headers \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000509 $GCC_OPTIONS --enable-languages="c" $USE_GOLD \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000510 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000511 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
512 --with-pkgversion="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE" \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000513 || touch .failed
Patrick Georgi969cd932012-12-07 13:13:53 +0100514 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-gcc || touch .failed
515 $MAKE install-gcc DESTDIR=$DESTDIR || touch .failed
516
517 if [ "`echo $TARGETARCH | grep -c -- -mingw32`" -eq 0 ]; then
518 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-target-libgcc || touch .failed
519 $MAKE install-target-libgcc DESTDIR=$DESTDIR || touch .failed
520 fi
521
Stefan Reinauer074d9132009-09-26 16:43:17 +0000522 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200523) > ${BUILDDIRPREFIX}-gcc/crossgcc-build.log 2>&1
524test -r ${BUILDDIRPREFIX}-gcc/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100525 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200526test -r ${BUILDDIRPREFIX}-gcc/.failed && exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000527fi
528
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200529if [ -f ${BUILDDIRPREFIX}-expat/.success ]; then
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100530 printf "Skipping Expat as it is already built\n"
Stefan Reinauer1200ec52011-11-01 22:39:41 +0100531elif [ $SKIPPYTHON -eq 1 ]; then
532 printf "Skipping Expat (Python scripting not enabled)\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100533else
534printf "Building Expat ${EXPAT_VERSION} ... "
535(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200536 cd ${BUILDDIRPREFIX}-expat
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100537 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100538 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${EXPAT_DIR}/configure --disable-shared \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100539 --prefix=$TARGETDIR --target=${TARGETARCH} || touch .failed
540 $MAKE || touch .failed
541 $MAKE install DESTDIR=$DESTDIR || touch .failed
Patrick Georgi198d23c2012-12-08 08:02:44 +0100542
543 normalize_dirs
544
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100545 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200546) > ${BUILDDIRPREFIX}-expat/crossgcc-build.log 2>&1
547test -r ${BUILDDIRPREFIX}-expat/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100548 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200549test -r ${BUILDDIRPREFIX}-expat/.failed && exit 1
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100550fi
551
552
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200553if [ -f ${BUILDDIRPREFIX}-python/.success ]; then
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100554 printf "Skipping Python as it is already built\n"
Stefan Reinauer1200ec52011-11-01 22:39:41 +0100555elif [ $SKIPPYTHON -eq 1 ]; then
556 printf "Skipping Python (Python scripting not enabled)\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100557else
558printf "Building Python ${PYTHON_VERSION} ... "
559(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200560 cd ${BUILDDIRPREFIX}-python
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100561 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100562 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${PYTHON_DIR}/configure --prefix=$TARGETDIR \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100563 --target=${TARGETARCH} || touch .failed
564 $MAKE $JOBS || touch .failed
565 $MAKE install DESTDIR=$DESTDIR || touch .failed
Patrick Georgi198d23c2012-12-08 08:02:44 +0100566
567 normalize_dirs
568
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100569 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200570) > ${BUILDDIRPREFIX}-python/crossgcc-build.log 2>&1
571test -r ${BUILDDIRPREFIX}-python/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100572 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200573test -r ${BUILDDIRPREFIX}-python/.failed && exit 1
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100574fi
575
576
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200577if [ -f ${BUILDDIRPREFIX}-gdb/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000578 printf "Skipping GDB as it is already built\n"
Peter Stugeceacd772011-06-09 04:54:16 +0200579elif [ $SKIPGDB -eq 1 ]; then
Stefan Reinauer1200ec52011-11-01 22:39:41 +0100580 printf "Skipping GDB (GDB support not enabled)\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000581else
582printf "Building GDB ${GDB_VERSION} ... "
583(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200584 cd ${BUILDDIRPREFIX}-gdb
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100585 export PYTHONHOME=$DESTDIR$TARGETDIR
Stefan Reinauer074d9132009-09-26 16:43:17 +0000586 rm -f .failed
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100587 LDFLAGS="-Wl,-rpath,\$\$ORIGIN/../lib/ -L$DESTDIR$TARGETDIR/lib \
588 -lpthread -ldl -lutil" \
Patrick Georgi643c9e82011-11-04 21:30:49 +0100589 CC="$CC" CFLAGS="$HOSTCFLAGS -I$DESTDIR$TARGETDIR/include" \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100590 ../gdb-${GDB_VERSION}/configure --prefix=$TARGETDIR \
591 --target=${TARGETARCH} --disable-werror --disable-nls
Patrick Georgi73166c72010-04-14 20:42:42 +0000592 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000593 $MAKE install DESTDIR=$DESTDIR || touch .failed
594 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200595) > ${BUILDDIRPREFIX}-gdb/crossgcc-build.log 2>&1
596test -r ${BUILDDIRPREFIX}-gdb/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100597 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200598test -r ${BUILDDIRPREFIX}-gdb/.failed && exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000599fi
600
Patrick Georgi6e61ad32012-05-12 23:19:30 +0200601if [ -f $IASL_DIR/source/compiler/.success ]; then
Marc Jones2aac3f62011-08-08 16:07:50 -0600602 printf "Skipping IASL as it is already built\n"
603else
604printf "Building IASL ${IASL_VERSION} ... "
605(
Idwer Vollering6b11c8b2012-11-15 21:14:36 +0100606 cd $IASL_DIR/generate/unix
Stefan Reinauer4266b922012-12-05 16:18:32 -0800607 rm -f .failed
Marc Jones2aac3f62011-08-08 16:07:50 -0600608 CFLAGS="$HOSTCFLAGS"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700609 HOST="_LINUX"
610 test $UNAME = "Darwin" && HOST="_APPLE"
611 test $UNAME = "FreeBSD" && HOST="_FreeBSD"
612 test $UNAME = "Cygwin" && HOST="_CYGWIN"
613 HOST="$HOST" OPT_CFLAGS="-O -D_FORTIFY_SOURCE=2" CFLAGS="$CFLAGS" $MAKE CC="$CC" iasl || touch .failed
Stefan Reinauer4266b922012-12-05 16:18:32 -0800614 rm -f $DESTDIR$TARGETDIR/bin/iasl || touch .failed
Zheng Bao3c4bd912013-08-27 10:23:13 +0800615 cp bin/iasl $DESTDIR$TARGETDIR/bin || touch .failed
Stefan Reinauer4266b922012-12-05 16:18:32 -0800616 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi6e61ad32012-05-12 23:19:30 +0200617) > $IASL_DIR/source/compiler/crossgcc-build.log 2>&1
Stefan Reinauer4266b922012-12-05 16:18:32 -0800618test -r $IASL_DIR/generate/unix/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100619 printf "${green}ok${NC}\n"
Stefan Reinauer4266b922012-12-05 16:18:32 -0800620test -r $IASL_DIR/generate/unix/.failed && exit 1
Marc Jones2aac3f62011-08-08 16:07:50 -0600621fi
622
Zheng Bao30b895f2013-02-06 18:04:40 +0800623rm -f $DESTDIR$TARGETDIR/$0.commit.*
624cp $0 $DESTDIR$TARGETDIR/"$0.commit.`git describe`"
625
Stefan Reinauer074d9132009-09-26 16:43:17 +0000626if [ $SAVETEMPS -eq 0 ]; then
627 printf "Cleaning up... "
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200628 rm -rf ${GMP_DIR} ${BUILDDIRPREFIX}-gmp
629 rm -rf ${MPFR_DIR} ${BUILDDIRPREFIX}-mpfr
630 rm -rf ${MPC_DIR} ${BUILDDIRPREFIX}-mpc
631 rm -rf ${LIBELF_DIR} ${BUILDDIRPREFIX}-libelf
632 rm -rf ${BINUTILS_DIR} ${BUILDDIRPREFIX}-binutils
633 rm -rf ${GCC_DIR} ${BUILDDIRPREFIX}-gcc
634 rm -rf ${GDB_DIR} ${BUILDDIRPREFIX}-gdb
635 rm -rf ${EXPAT_DIR} ${BUILDDIRPREFIX}-expat
636 rm -rf ${PYTHON_DIR} ${BUILDDIRPREFIX}-python
Marc Jones2aac3f62011-08-08 16:07:50 -0600637 rm -rf ${IASL_DIR}
Stefan Reinauer074d9132009-09-26 16:43:17 +0000638 printf "${green}ok${NC}\n"
639else
640 printf "Leaving temporary files around... ${green}ok${NC}\n"
641fi
642
643printf "\n${green}You can now run your $TARGETARCH cross toolchain from $TARGETDIR.${NC}\n"
644
645